-- Indierock's Bumper (modified ver. of Balloon Park Bumpers)
-- Originally from [DRRR]/data/scripts.pk3 by TehRealSalt

freeslot("MT_IRZ_BUMPER", "S_IRZ_BUMPER", "S_IRZ_BUMPERHIT", "SPR_IRBP", "SFX_S3ACI")

mobjinfo[MT_IRZ_BUMPER] = {
	//$Sprite IRBPA0
	//$Name Indierock Rally Bumper
	spawnstate = S_IRZ_BUMPER,
	seestate = S_IRZ_BUMPERHIT,
	radius = 32*FRACUNIT,
	height = 84*FRACUNIT,
	doomednum = 5100,
	dispoffset = 0,
	deathstate = S_NULL,
	deathsound = sfx_s3aci,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

states[S_IRZ_BUMPER] = {SPR_IRBP, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_IRZ_BUMPER}
states[S_IRZ_BUMPERHIT] = {SPR_IRBP, FF_ANIMATE|FF_FULLBRIGHT|A, 12, nil, 3, 3, S_IRZ_BUMPER}

local BUMPER_STRENGTH = 32

addHook("TouchSpecial", function(bumper, pmo)
	local hang = R_PointToAngle2(
		bumper.x, bumper.y,
		pmo.x, pmo.y
	)
	local vang = 0

	if (P_IsObjectOnGround(pmo) == false)
		vang = R_PointToAngle2(
			FixedHypot(bumper.x, bumper.y), bumper.z + (bumper.height >> 1),
			FixedHypot(pmo.x, pmo.y), pmo.z + (pmo.height >> 1)
		)
	end

	local str = (BUMPER_STRENGTH * bumper.scale) >> 1

	pmo.momx = FixedMul(FixedMul(str, cos(hang)), abs(cos(vang)))
	pmo.momy = FixedMul(FixedMul(str, sin(hang)), abs(cos(vang)))
	pmo.momz = FixedMul(str, sin(vang))

	if (pmo.player and pmo.player.valid)
		if (pmo.player.tiregrease == 0)
			for i = 0,1 do
				local grease = P_SpawnMobjFromMobj(pmo, 0, 0, 0, MT_TIREGREASE)
				grease.target = pmo
				grease.angle = pmo.angle
				grease.extravalue1 = i
			end
		end

		if (pmo.player.tiregrease < 2*TICRATE) // greasetics
			pmo.player.tiregrease = 2*TICRATE
		end
	end

	if (bumper.state != bumper.info.seestate)
		S_StartSound(bumper, bumper.info.deathsound)
		bumper.state = bumper.info.seestate
	end

	return true
end, MT_IRZ_BUMPER)
